(function () {

    var app = angular.module('mPOWER');

    var AppVersionMgmt = function ($http, $ionicLoading, $ionicPopup, $state) {
        var checkVersionUpdate = function (callBk) {
            
           getPlayStoreOrAppStoreVersion("3.0.21",callBk);
            
        }
        
        function getPlayStoreOrAppStoreVersion(AppVersion,callBk)
        {
          var isIOS = ionic.Platform.isIOS();
          var isAndroid = ionic.Platform.isAndroid();
          var plStoreOrApStoreVersion = "";
          var url = "";
          if(isIOS)
          {
              url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBXS/RSAppVersion?app_name=MPOWER&os=IOS";
          }
          else if(isAndroid)
          {
              url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/RDBXS/RSAppVersion?app_name=MPOWER&os=ANDROID";
          }
        
          $http.get(url)
              .success(function(data) {
                   if (data) 
                  {         
                      if (data.MobileAppVersions && data.MobileAppVersions.length > 0) {
                          dbVersion = data.MobileAppVersions[0].appVersion;
                          var a = dbVersion.split('.');
                          var b = AppVersion.split('.');
                          dbVersion = parseInt(a[0]+a[1]+a[2]);
                          AppVersion = parseInt(b[0]+b[1]+b[2]);
                          if ( AppVersion < dbVersion ) {
                              console.log('App version '+AppVersion);
                              console.log('Db version '+dbVersion);
                              $state.go('versionMgmt');
                          }
                          else {
                              callBk();
                          }
                      }
                      else {
                              callBk();
                      }    
                            
                  }
                  else
                  {
                      callBk();
                  }
              }).error(function() {
                 callBk();
              });
              
          
        }
        return {
            checkVersionUpdate: checkVersionUpdate,
            
        }
    };
    app.factory("AppVersionMgmt", AppVersionMgmt);

} ());