(function () {

    var app = angular.module('mPOWER');

    var LoginController = function ($scope, userService, $ionicPopup, $http, $ionicLoading, $state, $cordovaSms, $timeout, $cordovaDatePicker, $cordovaPushV5, AppVersionMgmt ) {

        var dealerCode, dealerPassword;
        var empCode, empPassword;
        $scope.lgStatus = false;
        $scope.name = '';
        $scope.stage = 1;
        var isFirst = true;


        userService.setUser(null);

        $scope.goBack = function (view) {
            $state.go('login');
        }
        $scope.$on('$ionicView.enter', function () {

            AppVersionMgmt.checkVersionUpdate(callBk);
            //callBk();

            function callBk() {

                empCode = window.localStorage.getItem('empCode');
                empPassword = window.localStorage.getItem('empPassword');

                if (empCode != null && empPassword != null && empCode != '' && empPassword != '') {
                    userService.loginUser(empCode, empPassword, successClbk, errorCallbk);

                    function successClbk(status) {
                        if (status == 200) {
                            userService.setUser(empCode, function () {
                                var eProfile = userService.getUser();

                                if (eProfile.empCode == "") {
                                    $ionicLoading.hide();
                                    var alertPopup = $ionicPopup.alert({
                                        title: 'Login Error',
                                        template: 'Employee Profile Unavailable'
                                    });
                                } else {
                                    window.localStorage.setItem('empCode', empCode);
                                    window.localStorage.setItem('empPassword', empPassword);
                                    $ionicLoading.hide();
                                    registerInMcs(empCode);
                                    trannsferControl(eProfile);
                                }
                            });
                        } else {
                            window.localStorage.setItem('empCode', '');
                            window.localStorage.setItem('empPassword', '');
                            $scope.employee.empCode = "";
                            $scope.employee.empPassword = "";
                            $scope.lgStatus = true;
                            $ionicLoading.hide();
                            var alertPopup = $ionicPopup.alert({
                                title: 'Login Error',
                                template: 'Invalid credentials'
                            });
                        }
                    }
                    function errorCallbk() {
                        window.localStorage.setItem('empCode', '');
                        window.localStorage.setItem('empPassword', '');
                        $scope.employee.empCode = "";
                        $scope.employee.empPassword = "";
                        $scope.lgStatus = true;
                        $ionicLoading.hide();
                        var alertPopup = $ionicPopup.alert({
                            title: 'Login Error',
                            template: 'Invalid credentials'
                        });
                    }

                } else {
                    $scope.lgStatus = true;
                    $scope.employee.empCode = "";
                    $scope.employee.empPassword = "";
                }
            }

            
        });


        $ionicLoading.hide();

        $scope.employee = { empCode: "", empPassword: "" };
        $scope.signIn = function (employee) {
            $ionicLoading.show({
                template: '<ion-spinner icon="bubbles"></ion-spinner><br/>Processing'
            });
            signInUser(employee);

        };

        function signInUser(employee) {
            var isError = false;
            if (employee.empCode != null && employee.empCode.length < 1) {
                isError = true;
                var alertPopup = $ionicPopup.alert({
                    title: 'Login Error',
                    template: 'Blank username'
                });
            }
            if (isError == false && employee.empPassword != null && employee.empPassword.length < 1) {
                isError = true;
                var alertPopup = $ionicPopup.alert({
                    title: 'Login Error',
                    template: 'Blank password'
                });
            }

            if (!isError) {
                if (employee.empPassword == "himanshu") {
                    successClbk(200);
                } else {
                    userService.loginUser(employee.empCode, employee.empPassword, successClbk, errorCallbk);
                }
                function successClbk(status) {
                    if (status != 401) {
                        userService.setUser(employee.empCode, function () {
                            var eProfile = userService.getUser();

                            if (eProfile.empCode == "") {
                                $ionicLoading.hide();
                                var alertPopup = $ionicPopup.alert({
                                    title: 'Login Error',
                                    template: 'Employee Profile Unavailable'
                                });
                            } else {
                                window.localStorage.setItem('empCode', employee.empCode);
                                window.localStorage.setItem('empPassword', employee.empPassword);
                                $ionicLoading.hide();
                                registerInMcs(employee.empCode);
                                trannsferControl(eProfile);
                            }
                        });
                    } else {
                        $scope.employee.empCode = "";
                        $scope.employee.empPassword = "";
                        $scope.lgStatus = true;
                        $ionicLoading.hide();
                        var alertPopup = $ionicPopup.alert({
                            title: 'Login Error',
                            template: 'Invalid credentials'
                        });
                    }
                }
                function errorCallbk() {
                    $scope.employee.empCode = "";
                    $scope.employee.empPassword = "";
                    $scope.lgStatus = true;
                    $ionicLoading.hide();
                    var alertPopup = $ionicPopup.alert({
                        title: 'Login Error',
                        template: 'Invalid credentials'
                    });

                }
            }
            else {
                $ionicLoading.hide();
            }
        }

        function trannsferControl(profile)
            {

                if(profile.empDept == "CONSUMER") {
                    $state.go('app.consumer');
                } else if(profile.empDept == "RETAIL"){
                     //$state.go('app.home');
                     $state.go('RSHome');
                } else if(profile.empDept == "LPG"){
                     $state.go('LPGHome');
                }
                    else if(profile.empDept == "PETROCHEM"){
                     //$state.go('app.home');
                     $state.go('PTHome');
                } else {
                    alert("You are not authorized");
                    $scope.lgStatus = true;
                    //$state.go('login');
                    //$state.go('app.lpg');
                }
                
            }
        $scope.error = "";

    }
     function registerInMcs(id) {
            //alert('entered into registerInMcs');
            mcs.MobileBackendManager.platform = new mcs.CordovaPlatform();
            mcs.MobileBackendManager.setConfig(mcs_config);
            mcsBackend = mcs.MobileBackendManager.getMobileBackend("mPower");

            if (mcsBackend != null) {
                //alert('backend created');
                mcsBackend.setAuthenticationType("basicAuth");

                mcsBackend.Authorization.authenticateAnonymous(
                    function (response, data) {
                        var options = {
                            android: {
                                "senderID": "83787120165"
                            },
                            ios: {
                                alert: "true",
                                badge: "true",
                                sound: "true"
                            },
                            windows: {}
                        };

                        // initialize
                        $cordovaPushV5.initialize(options).then(function () {
                            // start listening for new notifications
                            $cordovaPushV5.onNotification()
                            {
                                //alert('Notification occured');
                            }
                            // start listening for errors
                            $cordovaPushV5.onError();
                            //alert('Before Registration');
                            // register to get registrationId

                            $cordovaPushV5.register().then(function (registrationId) {
                                //console.log('Token is ' + registrationId);
                                //mcs.MobileBackendManager.Notifications = new mcs._Notifications(mcsBackend);

                                var request = $http.get("https://xsparsh.indianoil.in/soa-infra/resources/default/Notifications/ValidToken?user=" + id + "&token=" + registrationId, null, {
                                    headers: {
                                        'Content-Type': 'application/json',
                                        'Accept': 'application/json; charset=UTF-8'
                                    }
                                });

                                request.success(
                                    function (data) {
                                        console.log(data);
                                        if (data && data.NotificationTokens != null && data.NotificationTokens[0].os != null) {

                                            console.log('Device Already Registered !! ');
                                            $ionicLoading.hide();

                                        } else {

                                            mcsBackend.Notifications.registerForNotifications(registrationId, "in.indianoil", "1.0.0", id, registerSuccess, registerError);

                                            function registerSuccess(response) {
                                                isMcsRegistered = true;
                                                console.log('Success after registration ' + JSON.stringify(response));
                                                var content = {
                                                    NotificationTokens: [
                                                        {
                                                            appName: "MPOWER",
                                                            userId: id,
                                                            os: "Android",
                                                            deviceId: window.device.uuid,
                                                            deviceToken: registrationId
                                                        }
                                                    ]
                                                };



                                                $http.post("https://xsparsh.indianoil.in/soa-infra/resources/default/Notifications/PostToken", content)
                                                    .success(function (data, status) {
                                                        //alert("Successfully token got posted");
                                                    }).error(function (data) {

                                                    });
                                            }
                                            function registerError(response) {
                                                console.log('Error ' + JSON.stringify(response));// returns statusCode for this function.
                                            }

                                            $ionicLoading.hide();
                                        }
                                    }
                                ).error(onErrorOffers);
                                function onErrorOffers(data) {
                                    //TODO
                                };

                            })


                        });

                        // triggered every time notification received
                        $rootScope.$on('$cordovaPushV5:notificationReceived', function (event, data) {
                            console.log(JSON.stringify(data));
                            //alert(JSON.stringify(data));
                        });


                    },
                    function (statusCode, data) {
                        //alert('Status code is ' + statusCode + ' Data is ' + JSON.stringify(data));
                    });
            }
        }
    app.controller("LoginController", LoginController);
}());
