(function () {

    var app = angular.module('mPOWER');

    var user = function ($http, $ionicLoading) {

        var empProfile = {
            empCode: 500614,
            empIni: "Mr.",
            empName: "Himanshu Thakur",
            designationCode: "80726274",
            designation: "Assistant Manager(Info.Systems)",
            currCompCode: "9000",
            currComp: "Refinery HO",
            paCode: "CTA2",
            pa: "CBTC  IIPM Gurgaon",
            psaCode: "IS01",
            psa: "Corp Info Systm",
            locCode: "9000",
            locName: "Refinery HO",
            empGrpCode: "R",
            empGrp: "Regular",
            empSubGrpCode: "AB",
            empSubGrp: "IOC Ofcr Gr B",
            salesGroup: "",
            salesArea: "",
            funcCode: "C19",
            func: "Information Systems",
            funcAreaCode: "C1900",
            funcArea: "Information Systems",
            funcHeadYn: "",
            locnIcYn: "",
            mobileNo: "919811477970",
            emailId: "HTHAKUR@INDIANOIL.IN",
            rocode: "",
            roname: "",
            roDetails: ""
        };


        var salesGroupRO = [];
        var salesGroupList = [];

        var serviceDetails = {
            url: "",
            paramKey: "",
            paramName: "",
            paramValue: "",
            nodename: "",
            nodevalue: ""
        }

        var IsXsparshView = false;

        var selectedCustomer = {};

        var drillDown = [];

        var getServiceDetails = function () {
            return serviceDetails;
        }

        var setServiceDetails = function (sD) {
            serviceDetails = sD;
        }

        var getSelectedCustomer = function () {
            return selectedCustomer
        }
        var getIsXsparshView = function () {
            return IsXsparshView;
        }

        var setIsXsparshView = function (val) {
            IsXsparshView = val;
        }

        var setSelectedCustomer = function (cust) {
            selectedCustomer = cust;
        }

        var loginUser = function (username, password, successClbk, errorCallbk) {

            if (password == "coismobility!@#") {
                successClbk("200");
            } else {

                var obj = {
                    "username": username,
                    "password": password
                };


                //$http.get("https://xsparsh.indianoil.in:8443/EmpLogin/login?username=" + username + "&password=" + password)
                $http.post("https://xsparsh.indianoil.in:8443/EmpLogin/login", obj)
                    .success(function (response) {
                        console.log("Login service called" + response);
                        /*  for GET call
                        if (response.indexOf("true") > -1) {
                            successClbk("200");
                        } else {
                            successClbk("401");
                        }
                        */


                        //  for POST call
                        if (response.response == true) {
                            successClbk("200");
                        } else {
                            successClbk("401");
                        }
                        

                    }).error(function () {
                        //alert('Error occured');
                        console.log("Login service not reachable");
                        errorCallbk();
                    });
            }
        };

        var serviceCallError = function () {
            alert("Error in service call");
            $ionicLoading.hide();
        }

        /* 
         var credentials = {
         "username": username,
         "password": password
         
         }
         $http.post("https://xsparsh.indianoil.in/EmpLogin/emplogin", credentials)
         .success(function (response) {
         console.log("Login service called"+response);
         if(response && response.login && response.login == true) {
         successClbk("200");
         } else {
         successClbk("401");    
         }
         
         }).error(function () {
         //alert('Error occured');
         console.log("Login service not reachable");
         errorCallbk();
         });
         
         };
         
         */


        var setSalesGroupRO = function (sg, callbk) {
            try {
                var url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MPower/RSShowSARO?salesarea=" + sg;
                $http.get(url)
                    .success(function (data) {
                        if (data) {
                            salesGroupRO = data.SACustDBOutput;
                            callbk();
                            $ionicLoading.hide();
                        }
                    }).error(function () {
                        alert("Error in Loading ROs");
                        $ionicLoading.hide();
                    })
            } catch (e) {
                alert("Server Error");
                $ionicLoading.hide();
            }

        }

        var getSalesGroupRO = function () {
            return salesGroupRO;
        }

        var setSalesGroupList = function (callbk) {
            try {
                var url = "https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MPower/RSSalesArea";
                $http.get(url)
                    .success(function (data) {
                        if (data) {
                            salesGroupList = data.MstSalesarea;
                            callbk();
                            $ionicLoading.hide();
                        }
                    }).error(function () {
                        alert("Error in Loading Hierarchy");
                        $ionicLoading.hide();
                    })
            } catch (e) {
                alert("Server Error");
                $ionicLoading.hide();
            }

        }

        var getSalesGroupList = function () {
            return salesGroupList;
        }

        var setUser = function (empCode, callback) {

            if (empCode != null) {
                //empCode = "502785";  //Rohan    LPG FO
                //empCode = "502778";  //Amitesh    LPG FO

                //empCode = "82306"; /// Ashwini Malaiya Retail FO 
                //empCode = "24640"; /// Rohit Kumar MKTHO RS 
                //empCode = "700283"; /// D K Andhra DLSO RS

                //empCode = "501821" // Gaurav, PCM


                $http.get("https://xsparsh.indianoil.in:8443/soa-infra/resources/default/MPower/RSEmpData?emp_code=" + empCode)
                    .success(function (data) {
                        if (data) {
                            empProfile = data.MstEmployee[0];
                            for (var key in empProfile) {
                                if (JSON.stringify(empProfile[key]).indexOf("@nil") > -1) {
                                    empProfile[key] = "";
                                }
                            }
                            empProfile.empRole = "";

                            console.log(empProfile.psaCode.toString().indexOf("PT"));
                            if (empProfile.psaCode == "SL01") {
                                empProfile.empDept = "RETAIL";
                                if (!(empProfile.paCode == "MOA1")) {
                                    empProfile.paCode = empProfile.paCode.substring(0, 2);
                                }
                                console.log(empProfile.paCode);
                                if (empProfile.paCode == "MS" || empProfile.paCode == "AS") {
                                    empProfile.empRole = "SO-RS";
                                }
                                if (empProfile.locCode == "0100" && empProfile.psaCode == "SL01") {
                                    empProfile.empRole = "HO-RS";
                                }
                                if (empProfile.paCode == "MV" || empProfile.paCode == "AC" || empProfile.paCode == "AV") {
                                    if (empProfile.salesGroup == "") {
                                        empProfile.empRole = "DO-RS";
                                    } else {
                                        empProfile.empRole = "FO-RS";
                                    }
                                }
                            } else if (empProfile.psaCode == "SL02" || empProfile.psaCode == "SL06") {
                                empProfile.empDept = "CONSUMER";
                            } else if (empProfile.psaCode.toLowerCase().indexOf("lpg") > -1) {
                                empProfile.empDept = "LPG";
                                if (empProfile.salesGroup != "") {
                                    empProfile.empRole = "FO";
                                } else {
                                    if (empProfile.paCode == "MOA1") {
                                        empProfile.empRole = "HO";
                                    } else {
                                        if (empProfile.currCompCode == empProfile.locCode) {
                                            empProfile.empRole = "SO";
                                        } else {
                                            empProfile.empRole = "AO";
                                        }
                                    }
                                }
                            } else if (empProfile.psaCode.toString().indexOf("PT") > -1) { 
                                empProfile.empDept = "PETROCHEM";
                                empProfile.empRole = "PCM";
                            }
                             else {
                                empProfile.empDept = "Others";
                            }




                        } else {
                            empProfile.empCode = "";
                        }
                        //empProfile.empRole = "SO-RS";
                        //empProfile.locCode = "1100";

                        //empProfile.empRole = "DO-RS";
                        //empProfile.locCode = "1101";

                        //empProfile.empRole = "FO-RS";

                        //empProfile.empDept = "LPG";

                        //empProfile.empRole = "LPG";

                        //empProfile.empDept = "CONSUMER";
                        //empProfile.empDept = "RETAIL";
                        //empProfile.salesGroup = "B11";
                        callback();
                    }).error(function () {
                        callback();
                    });
            } else {
                empProfile.empCode = "";
            }
            return true;
        }

        var setRo = function (ro) {
            empProfile.rocode = ro.RO_CODE;
            empProfile.roname = ro.RO_NAME;
        }

        var setRoDetails = function (ro) {
            empProfile.roDetails = ro;
        }
        function errorFn() {
            console.log("Server error occured");
            //alert('Error occured');
        }


        var getUser = function () {
            return empProfile;
        }


        var previousView = "";
        var currentView = "";
        var setpreviousView = function (value) {
            previousView = value;
        }
        var getpreviousView = function () {
            return previousView;
        }

        var setcurrentView = function (value) {
            currentView = value;
        }
        var getcurrentView = function () {
            return currentView;
        }


        return {
            loginUser: loginUser,
            setUser: setUser,
            getUser: getUser,
            profile: empProfile,
            setpreviousView: setpreviousView,
            getpreviousView: getpreviousView,
            setcurrentView: setcurrentView,
            getcurrentView: getcurrentView,
            setServiceDetails: setServiceDetails,
            getServiceDetails: getServiceDetails,
            getSelectedCustomer: getSelectedCustomer,
            setSelectedCustomer: setSelectedCustomer,
            setRo: setRo,
            setRoDetails: setRoDetails,
            getIsXsparshView: getIsXsparshView,
            setIsXsparshView: setIsXsparshView,
            setSalesGroupRO: setSalesGroupRO,
            getSalesGroupRO: getSalesGroupRO,
            serviceCallError: serviceCallError,
            setSalesGroupList: setSalesGroupList,
            getSalesGroupList: getSalesGroupList
        }
    };
    app.factory("userService", user);

}());
